package ru.dbotthepony.mc.otm.capability;

import net.minecraft.server.level.ServerPlayer;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.food.FoodData;
import net.minecraftforge.fmllegacy.network.PacketDistributor;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.network.AndroidCapabilityChangePacket;
import ru.dbotthepony.mc.otm.network.MatteryNetwork;

import java.math.BigDecimal;
import java.util.Random;

public class AndroidCapabilityPlayer extends AndroidCapability {
	private final Player ply;

	public AndroidCapabilityPlayer(Player ent) {
		super(ent);
		ply = ent;
	}

	@Override
	protected void tickNetwork() {
		AndroidCapabilityChangePacket packet = writeChanges();

		if (packet != null)
			MatteryNetwork.ANDROID_PLAYER.send(PacketDistributor.PLAYER.with(() -> (ServerPlayer) ent), packet);
	}

	@Override
	public void tickInner() {
		super.tickInner();

		extractEnergyInner(BigDecimal.valueOf(new Random().nextDouble()), false);

		FoodData stats = ply.getFoodData();

		if (stats.needsFood()) {
			int food_points_missing = 20 - stats.getFoodLevel();
			boolean food_changed = false;
			float saturation_points_missing = 20F - stats.getSaturationLevel();
			boolean saturation_changed = false;

			while (food_points_missing > 0) {
				if (this.extractEnergyInner(ENERGY_FOR_HUNGER_POINT, true).equals(ENERGY_FOR_HUNGER_POINT)) {
					this.extractEnergyInner(ENERGY_FOR_HUNGER_POINT, false);
					food_points_missing--;
					food_changed = true;
				} else {
					break;
				}
			}

			while (saturation_points_missing >= 1F) {
				if (this.extractEnergyInner(ENERGY_FOR_HUNGER_POINT, true).equals(ENERGY_FOR_HUNGER_POINT)) {
					this.extractEnergyInner(ENERGY_FOR_HUNGER_POINT, false);
					saturation_points_missing--;
					saturation_changed = true;
				} else {
					break;
				}
			}

			if (food_changed) {
				stats.setFoodLevel(20 - food_points_missing);
			}

			if (saturation_changed) {
				stats.setSaturation(20F - saturation_points_missing);
			}
		}
	}
}
